Subject: Re: 3.0.0rc6: ethtool not working without a cable

From: Arkadiusz Miskiewicz <[email-masked]>
Date: Wed, 20 Jul 2011 19:57:39 +0200

On Wednesday 20 of July 2011, Brandeburg, Jesse wrote:
> On Wed, 6 Jul 2011, Arkadiusz Miskiewicz wrote:
> > On Wednesday 06 of July 2011, Ben Hutchings wrote:
> > > > If there is no cable then ethtool reports no device. It wasn't that
> > > > before AFAIK.
> > > > 
> > > > ethtool version 2.6.36
> > > > 
> > > > 
> > > > cable disconnected:
> > > > 
> > > > [root@t400 ~]# ethtool eth0
> > > > Settings for eth0:
> > > > Cannot get device settings: No such device
> > > > Cannot get wake-on-lan settings: No such device
> > > > Cannot get message level: No such device
> > > > Cannot get link status: No such device
> > > > No data available
> > > > zsh: exit 75    ethtool eth0
> > > > [root@t400 ~]# ethtool -i eth0
> > > > Cannot get driver information: No such device
> > > > zsh: exit 71    ethtool -i eth0
> 
> please check lspci -vvv on your device when cable is unplugged.  I'm
> wondering if OSPM (os power management) is kicking in (if enabled in your
> kernel) and somehow interacting badly with ethtool.
> 
> if the device is in D3, then most ethtool stuff won't work, since all the
> registers in the device (except in config space) don't work when in D3.

00:19.0 Ethernet controller: Intel Corporation 82567LM Gigabit Network 
Connection (rev 03)
        Subsystem: Lenovo Device 20ee
        Control: I/O- Mem- BusMaster- SpecCycle- MemWINV- VGASnoop- ParErr- 
Stepping- SERR+ FastB2B- DisINTx-
        Status: Cap+ 66MHz- UDF- FastB2B- ParErr- DEVSEL=fast >TAbort- 
<TAbort- <MAbort- >SERR- <PERR- INTx-
        Interrupt: pin A routed to IRQ 20
        Region 0: Memory at fc000000 (32-bit, non-prefetchable) [disabled] 
[size=128K]
        Region 1: Memory at fc025000 (32-bit, non-prefetchable) [disabled] 
[size=4K]
        Region 2: I/O ports at 1840 [disabled] [size=32]
        Capabilities: [c8] Power Management version 2
                Flags: PMEClk- DSI+ D1- D2- AuxCurrent=0mA 
PME(D0+,D1-,D2-,D3hot+,D3cold+)
                Status: D3 NoSoftRst- PME-Enable+ DSel=0 DScale=1 PME-
        Capabilities: [d0] MSI: Enable- Count=1/1 Maskable- 64bit+
                Address: 00000000fee0300c  Data: 41c5
        Capabilities: [e0] PCI Advanced Features
                AFCap: TP+ FLR+
                AFCtrl: FLR-
                AFStatus: TP-
        Kernel driver in use: e1000e
        Kernel modules: e1000e

-- 
Arkadiusz Miśkiewicz        PLD/Linux Team
arekm / maven.pl            http://ftp.pld-linux.org/